/*******************************************************************************
                             CHASING LEDS
                             ============

In this project 8 LEDs are connected to PORTC of a PIC18F45K22 microcontroller
and the microcontroller is operated from an 8MHz crystal. 

The program turns ON the LEDs in an anti-clockwise manner with one second delay
between each output. The net result is that LEDs seem to be chasing each other.


Author:                Dogan Ibrahim
Date:                August 2013
File:                MIKROC-LED1.C
*******************************************************************************/

void main()
{
     unsigned char i;
     
     ANSELC = 0;                                // Configure PORTC as digital
     TRISC = 0;                                 // Configure PORTC as output
     for(;;)                                            // Endless loop
     {
        for(i = 0; i < 3; i++)
        {
            PORTCBits.RC0 = 1;
            Delay_ms(10);
            PORTCbits.RC0 = 0;
            Delay_ms(10);
        }
        Delay_ms(2000);
     }
}