/*******************************************************************************
                             	COMPLEX FLASHING LED
                                ===================

In this project an LEDs is connected to port pin RC0 of a PIC18F45K22 microcontroller 
and the microcontroller is operated from an 8MHz crystal. 

The program flashes the LED continuously with the following pattern:

3 flashes with 200ms delay between each flash
2 seconds delay

Author:          Dogan Ibrahim
Date:            August 2013
File:            MIKROC-LED2.C
*******************************************************************************/

void main()
{
     unsigned char i;
     
     ANSELC = 0;                               		 	// Configure PORTC as digital
     TRISC = 0;                                 		// Configure PORTC as output
     for(;;)                                    		// Endless loop
     {
        for(i = 0; i < 3; i++)                  		// Do 3 times
        {
            PORTC.RC0 = 1;                      		// LED ON
            Delay_ms(200);                      		// 200ms delay
            PORTC.RC0 = 0;                      		// LED OFF
            Delay_ms(200);                      		// 200ms delay
        }
        Delay_ms(2000);                         		// 2 seconds delay
     }
}
