/*******************************************************************************
                            	RANDOM FLASHING LEDS
                             	====================

In this project 8 LEDs are connected to PORTC of a PIC18F45K22 microcontroller and the
microcontroller is operated from an 8MHz crystal. 

The program uses a pseudo-random number generator to generate a number between 0 and
32767. This number is then divided by 128 to limit it between 1 and 255. The resultant number
is sent to PORTC of the microcontroller. This process is repeated every second.


Author:          Dogan Ibrahim
Date:            August 2013
File:            MIKROC-LED3.C
*******************************************************************************/

void main()
{
     unsigned int p;
     
     ANSELC = 0;                                	// Configure PORTC as digital
     TRISC = 0;                                 	// Configure PORTC as output
     srand(10);                                 	// Initialize random number seed
     
     for(;;)                                    	// Endless loop
     {
        p = rand();                             	// Generate a random number
        p = p / 128;                            	// Number between 1 and 255
        PORTC = p;                              	// Send to PORTC
        Delay_ms(1000);                         	// 1 second delay
     }
}
