/*******************************************************************************
                             		LOGIC PROBE
                             		===========

This is a logic probe project. In this project 2 coloured LEDs are connected to PORTC pins
RC6 (RED) and RC7 (GREEN). In addition, RC0 is used as the probe input.

If the logic probe is at logic 0 then the RED LED is turned ON. Otherwise, the GREEN LED is 
turned ON.

Author:  Dogan Ibrahim
Date:    August 2013
File:    MIKROC-LED4.C
*******************************************************************************/
#define PROBE PORTC.RC0
#define RED_LED PORTC.RC6
#define GREEN_LED PORTC.RC7

void main()
{
     ANSELC = 0;                         	// Configure PORTC as digital
     TRISC0_bit = 1;                     	// Configure RC0 as input
     TRISC6_bit = 0;                     	// Configure RC6 as output
     TRISC7_bit = 0;                     	// Configure RC7 as output
     
     for(;;)                             	// Endless loop
     {
        if(PROBE == 0)                   	// If the signal is LOW
        {
          GREEN_LED = 0;                 	// Turn OFF GREEN LED
          RED_LED = 1;				// Torn ON RED LED
        }
        else
        {
          RED_LED = 0;				// Turn OFF RED LED
          GREEN_LED = 1;                 	// Turn ON GREEN LED
        }
     }
}
