/*******************************************************************************
             			SIMPLE DICE
             			===========

In this project 7 LEDs are connected to PORTC of a PIC18F45K22 microcontroller and the
microcontroller is operated from an 8MHz crystal. The LEDs are organised as the faces
of a real dice. When a push-button switch connected to RB0 is pressed a dice pattern is
displayed on the LEDs. The display remains in this state for 3 seconds and after this period
the LEDs all turn OFF to indicate that the system is ready for the button to be pressed again.


Author:		Dogan Ibrahim
Date:   	August 2013
File:   	MIKROC-LED5.C
********************************************************************************/

#define Switch PORTB.RB0
#define Pressed 0

void main()
{
     unsigned char J = 1;
     unsigned char Pattern;
     unsigned char DICE[] = {0,0x08,0x22,0x2A,0x55,0x5D,0x77};

     ANSELC = 0;                                	// Configure PORTC as digital
     ANSELB = 0;                                	// Configure PORTB as digital
     TRISC = 0;	                       			// Configure PORT C as outputs
     TRISB = 1;                       			// Configure RB0 as input
     PORTC = 0;                       			// Turn OFF all LEDs

     for(;;)                          			// Endless loop
     {
          if(Switch == Pressed)       			// Is switch pressed ?
          {
            Pattern = DICE[J];        			// Get LED pattern
            PORTC = Pattern;          			// Turn on LEDs
            Delay_ms(3000);           			// Delay 3 second
            PORTC = 0;                			// Turn OFF all LEDs
            J = 0;                    			// Initialise J
           }
           J++;                       			// Increment J
           if(J == 7) J = 1;          			// Back to 1 if  >  6
     }
}
