/*******************************************************************************
                        	7-SEGMENT DISPLAY
                        	=================

In this project a common anode 7-segment LED display is connected to PORTC of a PIC18F45K22 microcontroller and the microcontroller is operated from an 8MHz crystal. The program displays numbers 0 to 9 on the display with a one second delay between each output.

Author:   	Dogan Ibrahim
Date:     	August 2013
File:     	MIKROC-LED8.C
*******************************************************************************/

void main()
{
     unsigned char Pattern, Cnt = 0;
     unsigned char SEGMENT[] = {0x3F,0x06,0x5B,0x4F,0x66,0x6D,
        0x7D,0x07,0x7F,0x6F};

     ANSELC = 0;                                  	// Configure PORTC as digital
     TRISC = 0;                       		  	// Configure PORTC as outputs

     for(;;)                          		  	// Endless loop
     {
        Pattern = SEGMENT[Cnt];        			// Number to send to PORTC
        Pattern = ~Pattern; 				// Invert bit pattern
        PORTC = Pattern;               		  	// Send to PORTC
        Cnt++;                                    	// Increment Cnt
        if(Cnt == 10) Cnt = 0;         		  	// Cnt is between 0 and 9
        Delay_ms(1000);                		  	// 1 second delay
     }
}

