  /*****************************************************************************
                            	 MINI ELECTRONIC ORGAN
                             	======================

In this project a 4 x 4 keypad is connected to PORTC of a PIC18F45K22 microcontroller. Also a
buzzer is conncted to port pin RE1. The keypad is organized such that pressing a key plays a
musical note. The notes on the keypad are organized as follows:

C4    D4     E4     F4
G4    A4     B4     C5
C4#   D4#    F4#    G4#
A4#

Author:   Dogan Ibrahim
Date:     September 2013
File:     MIKROC-MUSIC.C
*******************************************************************************/
// Keypad module connections
char keypadPort at PORTC;
// End of keypad module connections

//
// Start of MAIN program
//
void main()
{
     unsigned char MyKey;
     unsigned Notes[] = {0,262,294,330,349,392,440,494,524,277,311,370,415,466};

     ANSELE = 0;                                        	// Configure PORTE as digital
     ANSELC = 0;                                        	// Configure PORTC as digital
     TRISC = 0xF0;                           			// RC4-RC7 are inputs

     Keypad_Init();                                      	// Initialize keypad library
     Sound_Init(&PORTE, 1);                                	// Initialize sound library
//
// Program loop
//
     for(;;)                                 			// Endless loop
     {
          do
               MyKey = Keypad_Key_Press();         		// Get code of pressed key
          while(!MyKey);

          if(MyKey <= 13)Sound_Play(Notes[MyKey], 100); 	// Play the note
     }
}

