/*******************************************************************************
                  		CALCULATOR WITH PC INTERFACE
                  		============================

In this project a PC is connected to a PIC18F45K22 microcontroller. The project is a simple integer calculator. User enters the numbers using the PC keyboard.  Results are displayed on the PC
monitor.

The following operations can be performed:

    + - * /

This program uses the built in USART of the microcontroller. The USART is  configured to operate with 9600 Baud rate.

The serial TX pin is RC6 and the serial RX pin is RC7.

Author:   Dogan Ibrahim
Date:     September 2013
File:     MIKRO-RS232-2.C
*******************************************************************************/

#define Enter 13
#define Plus '+'
#define Minus '-'
#define Multiply '*'
#define Divide '/'

//
// This functions send carriage-return and line-feed to USART
//
void Newline()
{
    Uart1_Write(0x0D);                          		// Send carriage-return
    Uart1_Write(0x0A);                        			// Send line-feed
}


void main()
{
     unsigned char MyKey, i,j,kbd[12];
     unsigned char *op;
     unsigned long Calc, Op1, Op2,Key;
     unsigned char msg1[] = "CALCULATOR PROGRAM";
     unsigned char msg2[] = "    Enter First Number: ";
     unsigned char msg3[]=  "  Enter Second Nummber: ";
     unsigned char msg4[] = "       Enter Operation: ";
     unsigned char msg5[] = "               Result = ";
     
     ANSELC = 0;
//
// Configure the USART
//
    Uart1_Init(9600);                           		// Baud=9600
//
// Program loop
//
     for(;;)                                   			// Endless loop
     {
        MyKey = 0;
        Op1 = 0;
        Op2 = 0;

        Newline();                              		// Send newline
        Newline();                              		// Send newline
        Uart1_Write_Text(msg1);                    		// Send TEXT
        Newline();                              		// Send newline
        Newline();                              		// Send newline

//
// Get the first number
//
        Uart1_Write_Text(msg2);                    		// Send TEXT to USART
        do                                      		// Get first number
        {
            if(Uart1_Data_Ready())              		// If a character ready
            {
                MyKey = Uart1_Read();           		// Get a character
                if(MyKey == Enter)break;        		// If ENTER key
                Uart1_Write(MyKey);             		// Echo the character
                Key = MyKey - '0';
                Op1 = 10*Op1 + Key;             		// First number in Op1
            }
        }while(1);

        Newline();

//
// Get the second character
//
        Uart1_Write_Text(msg3);                    		// Send TEXT to USART
        do                                      		// Get second number
        {
            if(Uart1_Data_Ready())
            {
                MyKey = Uart1_Read();           		// Get a character
                if(Mykey == Enter)break;        		// If ENTER key
                Uart1_Write(MyKey);             		// Echo the character
                Key = MyKey - '0';
                Op2 = 10*Op2 + Key;             		// Second number in Op2
            }
           }while(1);

         Newline();
//
// Get the operation
//
         Uart1_Write_Text(msg4);
         do
         {
            if(Uart1_Data_Ready())
            {
                MyKey = Uart1_Read();           		// Get a character
                if(MyKey == Enter)break;        		// If ENTER key
                Uart1_Write(MyKey);             		// Echo the character
                Key = MyKey;
             }
         }while(1);

//
// Perform the operation
//
        Newline();
        switch(Key)                                   		// Calculate
        {
          case Plus:
                  Calc = Op1 + Op2;                   		// If ADD
                  break;
          case Minus:
                  Calc = Op1 - Op2;                   		// If Subtract
                  break;
          case Multiply:
                  Calc = Op1 * Op2;                   		// If Multiply
                  break;
          case Divide:
                  Calc = Op1 / Op2;                   		// If Divide
                  break;
        }

        LongToStr(Calc, kbd);                          		// Convert to string
        op = Ltrim(kbd);
        Uart1_Write_Text(msg5);
        Uart1_Write_Text(op);         				// Display result

     }
}

