/*******************************************************************************
                          	PLAYING MELODY
                          	==============

In this project a buzzer is connected to port pin RC2 of a PIC18F45K22 microcontroller,
operating with an 8MHz crystal.

The program plays the classical "Happy Birthday" melody.


Author:           Dogan Ibrahim
Date:             August 2013
File:             MIKROC-SOUND1.C
**************************************************************/
#define Max_Notes 25

void main()
{
     unsigned char i;
     
     unsigned int Notes[Max_Notes] =
     {
       262, 262, 294, 262, 349, 330, 262, 262, 294, 262, 392,
       349, 262, 262, 524, 440, 349, 330, 294, 466, 466, 440,
       349, 392, 349
     };
     
     unsigned char Durations[Max_Notes] =
     {
       1, 1, 2, 2, 2, 3, 1, 1, 2, 2, 2, 3, 1, 1, 2, 2, 2, 2, 2,
       1, 1, 2, 2, 2, 3
     };

     ANSELC = 0;                                   		// Configure PORTC as digital

     Sound_Init(&PORTC, 2);                        		// Initialize the Sound library
     
     for(;;)                                      		// Endless loop
     {
       for(i = 0; i < Max_Notes; i++)             		// Do for all notes
       {
          Sound_Play(Notes[i], 400*Durations[i]);     		// Play the notes
          Delay_ms(100);                               		// Note gap
       }
       Delay_Ms(3000);                                 		// Repeat after 3 seconds
     }
}
