/******************************************************************************
                             	GENERATE SQUARE WAVE
                             	====================

In this project a square wave signal with frequency 1kHz is generated. The program uses timer interrupts to send the signal to output.

Timer0 is configured to provide interrupts at every 0.5ms. Inside the ISR the output pin is toggled, thus generating a square wave signal.

Author:      Dogan Ibrahim
Date:        September 2013
File:        MIKROC-WAVE6.C
********************************************************************************/

#define OUT_PIN LATD.LATD0
//
// Timr ISR. Program jumps here at every 100 microseconds
//
void interrupt (void)
{
       TMR0L = 131;                                      	// Re-load timer register
       OUT_PIN = ~OUT_PIN;                               	// Toggle the output pin
       INTCON.TMR0IF = 0;                                	// Clear timer interrupt flag
}


void main()
{
     ANSELD = 0;                                         	// Configure PORTC as digital
     TRISD = 0;
     OUT_PIN = 0;
//
 // Configure TIMER0 interrupts
 //
     T0CON = 0xC2;                                      	// TIMER0 in 8-bit mode
     TMR0L = 131;                                               // Load Timer register
     INTCON = 0xA0;                                     	// Enable global and Timer0 interrupts
     for(;;)                                            	// Wait for interrupts
     {
     }
}
