/**********************************************************************************
             				CHASING LEDS
             				============

In this project 8 LEDs are connected to PORTC of a PIC18F45K22 microcontroller and the
microcontroller is operated from an 8MHz crystal.

The program turns ON the LEDs in an anti-clockwise manner with one second delay between
each output. The net result is that LEDs seem to be chasing each other.


Author:	        Dogan Ibrahim
Date:		August 2013
File:		XC8-LED1.C
************************************************************************************/
#include <xc.h>
#pragma config MCLRE = EXTMCLR, WDTEN = OFF, FOSC = HSHP
#define _XTAL_FREQ 8000000

//
// This function creates seconds delay. The argument specifies the delay time in seconds
//
void Delay_Seconds(unsigned char s)
{
    unsigned char i,j;

    for(j = 0; j < s; j++)
    {
        for(i = 0; I <  100; i++)__delay_ms(10);
    }
}


void main()
{
     unsigned char J = 1;

     ANSELC = 0;                                		// Configure PORTC as digital
     TRISC = 0;                                 		// Configure PORTC as output

     for(;;)          	          				// Endless loop
     {
            PORTC = J;    	       				// Send J to PORT C
            Delay_Seconds(1);     				// Delay 1 second
            J = J << 1;          				// Shift left J
            if(J == 0) J = 1;     				// If last LED,move to first one
     }
}
