/*******************************************************************************
                             	COMPLEX FLASHING LED
                                ====================

In this project an LEDs is connected to port pin RC0 of a PIC18F45K22 
microcontroller and the the microcontroller is operated from an 8MHz crystal.

The program flashes the LED continuously with the following pattern:

    3 flashes with 200ms delay between each flash
    2 seconds delay

Author:       Dogan Ibrahim
Date:         August 2013
File:         XC8-LED2.C
*******************************************************************************/
#include <xc.h>
#pragma config MCLRE = EXTMCLR, WDTEN = OFF, FOSC = HSHP
#define _XTAL_FREQ 8000000

//
// This function creates milliseconds delay. The argument specifies the delay time
// The delay can be 1 to 65535ms
//
void DelayMs(unsigned int ms)
{
    unsigned int j;

    for(j = 0; j < ms; j++)__delay_ms(1);
}


void main()
{
     unsigned char i;

     ANSELC = 0;                               		// Configure PORTC as digital
     TRISC = 0;                                		// Configure PORTC as output
     for(;;)          	          	       		// Endless loop
     {
        for(i = 0; i < 3; i++)                 		// Do 3 times
        {
            PORTCbits.RC0 = 1;                 		// LED ON
            DelayMs(200);                      		// 200ms delay
            PORTCbits.RC0 = 0;                 		// LED OFF
            DelayMs(200);                      		// 200ms delay
        }
        DelayMs(2000);
     }
}
