/*******************************************************************************
                             		LOGIC PROBE
                             		===========

This is a logic probe project. In this project 2 coloured LEDs are connected to PORTC pins RC6
(RED) and RC7 (GREEN). In addition, RC0 is used as the probe input.

If the logic probe is at logic 0 then the RED LED is turned ON. Otherwise, the GREEN LED is 
turned ON.

Author:      Dogan Ibrahim
Date:        August 2013
File:        XC8-LED4.C
*******************************************************************************/
#include <xc.h>
#pragma config MCLRE = EXTMCLR, WDTEN = OFF, FOSC = HSHP
#define _XTAL_FREQ 8000000

#define PROBE PORTCbits.RC0
#define RED_LED PORTCbits.RC6
#define GREEN_LED PORTCbits.RC7


void main()
{
     ANSELC = 0;                         		// Configure PORTC as digital
     TRISCbits.RC0 = 1;                     		// Configure RC0 as input
     TRISCbits.RC6 = 0;                     		// Configure RC6 as output
     TRISCbits.RC7 = 0;                     		// Configure RC7 as output

     for(;;)                             		// Endless loop
     {
        if(PROBE == 0)                   		// If the signal is LOW
        {
          GREEN_LED = 0;                		// Turn OFF GREEN LED
          RED_LED = 1;					// Turn ON RED LED
        }
        else
        {
          RED_LED = 0;					// Turn OFF RED LED
          GREEN_LED = 1;                 		// Turn ON GREEN LED
        }
     }
}
