/*******************************************************************************
             				SIMPLE DICE
             				==========

In this project 7 LEDs are connected to PORTC of a PIC18F45K22 microcontroller and the
microcontroller is operated from an 8MHz crystal. The LEDs are organised as the faces of a
real dice. When a push-button switch connected to RB0 is pressed a dice pattern is displayed
on the LEDs. The display remains in this state for 3 seconds and after this period the LEDs all
turn OFF to indicate that the system is ready for the button to be pressed again.

 The random number generator function is used in this program.
 * 
Author:		Dogan Ibrahim
Date:   	August 2013
File:   	XC8-LED5-1.C
********************************************************************************/

#include <xc.h>
#include <stdlib.h>
#pragma config MCLRE = EXTMCLR, WDTEN = OFF, FOSC = HSHP
#define _XTAL_FREQ 8000000

#define Switch PORTBbits.RB0
#define Pressed 0

//
// This function creates seconds delay. The argument specifies the delay time in seconds
//
void Delay_Seconds(unsigned char s)
{
    unsigned char i,j;

    for(j = 0; j < s; j++)
    {
        for(i = 0; i <  100; i++)__delay_ms(10);
    }
}


void main()
{
     unsigned char J, Pattern, Seed = 1;
     unsigned char DICE[] = {0,0x08,0x22,0x2A,0x55,0x5D,0x77};

     ANSELC = 0;                                	// Configure PORTC as digital
     ANSELB = 0;                                	// Configure PORTB as digital
     TRISC = 0;	                       			// Configure PORT C as outputs
     TRISB = 1;                       			// Configure RB0 as input
     PORTC = 0;                       			// Turn OFF all LEDs
     srand(1);                                  	// Initialize rand function

     for(;;)                          			// Endless loop
     {
          if(Switch == Pressed)       			// Is switch pressed ?
          {
            J = rand() / 6553 + 1;              	// Generate a number 1 to 6
            Pattern = DICE[J];        			// Get LED pattern
            PORTC = Pattern;          			// Turn on LEDs
            Delay_Seconds(3);           		// Delay 3 second
            PORTC = 0;                			// Turn OFF all LEDs
           }
     }
}
