/******************************************************************************
                             	GENERATE SQUARE WAVE
                             	=====================

In this project a square wave signal with frequency 20kHz (period 50us) is generated. The
program uses the built-in PWM module to generate accurate square wave signal.

The output signal is available on pin RC2 (CCP1) of the microcontroller.

Author:      Dogan Ibrahim
Date:        September 2013
File:        XC8-WAVE7.C
********************************************************************************/
#include <xc.h>
#pragma config MCLRE = EXTMCLR, WDTEN = OFF, FOSC = HSHP
#define _XTAL_FREQ 8000000

void main()
{

   ANSELC = 0;                                    	// Configure PORT C as digital
   TRISC = 0;                                      	// PORT C as output

   T2CON = 0b00000101;                              	// Timer 2 with prescaler 4
   PR2 = 24;                                      	// Load PR2 register of Timer 2
   CCPTMRS0 = 0;					// Enable PWM
   CCPR1L = 0X0C;					// Load duty cycle
   CCP1CON = 0x2C;					// Load duty cycle and enable PWM

   for(;;)                                         	// Wait here forever
   {
   }
}
